package api

import (
	"errors"
	"spu3d/db/model"
	"spu3d/db/repo"

	"github.com/gin-gonic/gin"
	"go.mongodb.org/mongo-driver/bson/primitive"
)

// 这里需要nats获取通用用户信息,因为spu3d中功能聚合了lancher的功能
func getUserRole(_ *gin.Context, apictx *ApiSession) ([]string, error) {
	if apictx.User != nil {
		userId, _ := primitive.ObjectIDFromHex(apictx.User.Parent)
		var searchUser model.UserSmaple
		ok, err := repo.RepoSeachDoc(apictx.CreateRepoCtx(), &repo.DocSearchOptions{
			Db:          "usercenter",
			CollectName: "users",
			Query:       repo.Map{"_id": userId},
			Project:     []string{"roles"},
		}, &searchUser)
		if err != nil {
			return nil, errors.New("查询用户失败")
		}
		if !ok {
			return nil, errors.New("没有该用户信息")
		}
		return searchUser.Roles, nil

	} else {
		return nil, errors.New("用户未登录")
	}

}

func isSysUser(roles []string) bool {
	if len(roles) > 0 {
		for _, role := range roles {
			if role == "system" {
				return true
			}
		}
	}
	return false
}
